---
title: Using the application cache
slug: Web/HTML/Using_the_application_cache
tags:
  - Advanced
  - App
  - Cache
  - Guide
  - HTML
  - appcache
  - application cache
  - web cache
---
<div class="notecard warning">
<p><strong>Do not use this <em>application cache</em> feature!</strong> It is <a href="https://html.spec.whatwg.org/multipage/browsers.html#offline">in the process of being removed from the Web platform</a>.</p>

<ul>
 <li>From Firefox 84 it has been removed ({{bug("1619673")}}). It is also planned for removal in Chomium 90, and is deprecated in Safari.</li>
 <li>From Firefox 60, and in some or all <a href="/en-US/docs/Web/HTML/Using_the_application_cache#Browser_compatibility">supporting browsers</a>, it is only available in <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a> (HTTPS).</li>
 <li>As of Firefox 44+, when <a href="/en-US/docs/Web/HTML/Using_the_application_cache">AppCache</a> is used to provide offline support for a page, a warning message displays in the console advising developers to use <a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Service workers</a> instead ({{bug("1204581")}})</li>
</ul>
</div>

<div>{{DefaultAPISidebar("App Cache")}}{{Deprecated_Header}}{{SecureContext_Header}}</div>

<h2 id="Introduction">Introduction</h2>

<p><a href="/en-US/docs/HTML/HTML5">HTML5</a> provides an <em>application caching</em> mechanism that lets web applications run offline. This <strong>Application Cache</strong> (<em>AppCache</em>) interface lists resources that browsers should cache to be available offline. Applications that are cached load and work correctly offline, even if users press the Refresh button.</p>

<p>An application cache gives the following benefits:</p>

<dl>
 <dt>Offline browsing</dt>
 <dd>Users can navigate a site even when they are offline.</dd>
 <dt>Speed</dt>
 <dd>Cached resources are local, and therefore load faster.</dd>
 <dt>Reduced server load</dt>
 <dd>The browser only downloads resources that have changed from the server.</dd>
</dl>

<h2 id="How_the_application_cache_works">How the application cache works</h2>

<h3 id="Enabling_the_application_cache">Enabling the application cache</h3>

<p>To enable the application cache for an application, include the {{HTMLAttrxRef("manifest", "html")}} attribute in the {{HTMLElement("html")}} element:</p>

<pre class="brush: html notranslate">&lt;html manifest="/example.appcache"&gt;
  …
&lt;/html&gt;
</pre>

<p>The <code>manifest</code> attribute references a URL for a <strong>cache manifest</strong> file: a text file that lists URLs that browsers should cache for your application.</p>

<p>You <em>should</em> include the <code>manifest</code> attribute on each page of your site that you want cached. The browser does <em>not</em> cache pages without the <code>manifest</code> attribute, unless such pages are listed in the manifest file. You do not need to list all pages you want cached in the manifest file, the browser implicitly adds every page that the user visits and that has the <code>manifest</code> attribute set to the application cache.</p>

<p>Some browsers (e.g., Firefox) display a notification bar the first time a user loads an application that uses the application cache. The notification bar displays a message such as:</p>

<p style="margin-left: 40px;">This website (<code>example.com</code>) is asking to store data on your computer for offline use. [Allow] [Never for This Site] [Not Now]</p>

<p>The term "offline(-enabled) applications" sometimes refers specifically to applications that the user has allowed to use offline capabilities.</p>

<h3 id="Loading_documents">Loading documents</h3>

<p>The use of an application cache modifies the normal process of loading a document:</p>

<ul>
 <li>If an application cache exists, the browser loads the document and its associated resources directly from the cache, without accessing the network. This speeds up the document load time.</li>
 <li>The browser then checks to see if the cache manifest has been updated on the server.</li>
 <li>If the cache manifest has been updated, the browser downloads a new version of the manifest and the resources listed in the manifest. This is done in the background and does not affect performance significantly.</li>
</ul>

<p>The process for loading documents and updating the application cache is specified in greater detail below:</p>

<ol>
 <li>When the browser visits a document that includes the <code>manifest</code> attribute, if no application cache exists, the browser loads the document and then fetches all the entries listed in the manifest file, creating the first version of the application cache.</li>
 <li>Subsequent visits to that document cause the browser to load the document and other assets specified in the manifest file from the application cache (not from the server). In addition, the browser also sends a <code>checking</code> event to the <code><a href="/en-US/docs/DOM/window.applicationCache">window.applicationCache</a></code> object, and fetches the manifest file, following the appropriate HTTP caching rules.</li>
 <li>If the currently-cached copy of the manifest is up-to-date, the browser sends a <code>noupdate</code> event to the <code>applicationCache</code> object, and the update process is complete. Note that if you change any cached resources on the server, you must also change the manifest file itself, so that the browser knows it needs to fetch all the resources again.</li>
 <li>If the manifest file <em>has</em> changed, all the files listed in the manifest—as well as those added to the cache by calling <code><a href="/en-US/docs/nsIDOMOfflineResourceList#add.28.29">applicationCache.add()</a></code>—are fetched into a temporary cache, following the appropriate HTTP caching rules. For each file fetched into this temporary cache, the browser sends a <code>progress</code> event to the <code>applicationCache</code> object. If any errors occur, the browser sends an <code>error</code> event, and the update halts.</li>
 <li>Once all the files have been successfully retrieved, they are moved into the real offline cache automatically, and a <code>cached</code> event is sent to the <code>applicationCache</code> object. Since the document has already been loaded into the browser from the cache, the updated document will not be rendered until the document is reloaded (either manually or programatically).</li>
</ol>

<h2 id="Storage_location_and_clearing_the_offline_cache">Storage location and clearing the offline cache</h2>

<p>In Chrome you can clear the offline cache by selecting "Clear browsing data..." in the preferences or by visiting <a>chrome://appcache-internals/</a>. Safari has a similar "Empty cache" setting in its preferences but a browser restart may also be required.</p>

<p>In Firefox, the offline cache data is stored separately from the Firefox profile—next to the regular disk cache:</p>

<ul>
 <li>Windows Vista/7: <code>C:\Users\&lt;username&gt;\AppData\<strong>Local</strong>\Mozilla\Firefox\Profiles\&lt;salt&gt;.&lt;profile name&gt;\OfflineCache</code></li>
 <li>Mac/Linux: <code>/Users/&lt;username&gt;/Library/Caches/Firefox/Profiles/&lt;salt&gt;.&lt;profile name&gt;/OfflineCache</code></li>
</ul>

<p>In Firefox the current status of the offline cache can be inspected on the <code>about:cache</code> page (under the "Offline cache device" heading). The offline cache can be cleared for each site separately using the "Remove..." button in Tools -&gt; Options -&gt; Advanced -&gt; Network -&gt; Offline data.</p>

<p>Prior to Firefox 11, neither Tools -&gt; Clear Recent History nor Tools -&gt; Options -&gt; Advanced -&gt; Network -&gt; Offline data -&gt; Clear Now cleared the offline cache. This has been fixed.</p>

<p>On Linux, you can find the setting at Edit &gt; Preferences &gt; Advanced &gt; Network &gt; Offline Web Content and User Data</p>

<p>See also <a href="/en-US/docs/DOM/Storage#Storage_location_and_clearing_the_data">clearing the DOM Storage data</a>.</p>

<p>Application caches can also become obsolete. If an application's manifest file is removed from the server, the browser removes all application caches that use that manifest, and sends an "obsoleted" event to the <code>applicationCache</code> object. This sets the application cache's state to <code>OBSOLETE</code>.</p>

<h2 id="The_cache_manifest_file">The cache manifest file</h2>

<h3 id="Referencing_a_cache_manifest_file">Referencing a cache manifest file</h3>

<p>The <code>manifest</code> attribute in a web application can specify either the relative path of a cache manifest file or an absolute URL. (Absolute URLs must be from the same origin as the application). A cache manifest file can have any file extension, but it must be served with the MIME type <code>text/cache-manifest</code>.</p>

<div class="note"><strong>Note: </strong>On Apache servers, the MIME type for manifest (.appcache) files can be set by adding <code>AddType text/cache-manifest .appcache</code> to a .htaccess file within either the root directory, or the same directory as the application.</div>

<h3 id="Entries_in_a_cache_manifest_file">Entries in a cache manifest file</h3>

<p>The cache manifest file is a simple text file that lists the resources the browser should cache for offline access. Resources are identified by URI. Entries listed in the cache manifest must have the same scheme, host, and port as the manifest.</p>

<h3 id="Example_1_a_simple_cache_manifest_file">Example 1: a simple cache manifest file</h3>

<p>The following is a simple cache manifest file, <code>example.appcache</code>, for an imaginary web site at <span class="nowiki">www.example.com</span>.</p>

<pre class="eval notranslate">CACHE MANIFEST
# v1 - 2011-08-13
# This is a comment.
<span class="nowiki">http://www.example.com/index.html</span>
<span class="nowiki">http://www.example.com/header.png</span>
<span class="nowiki">http://www.example.com/blah/blah</span>
</pre>

<p>A cache manifest file can include three sections (<code>CACHE</code>, <code>NETWORK</code>, and <code>FALLBACK</code>, discussed below). In the example above, there is no section header, so all data lines are assumed to be in the explicit (<code>CACHE</code>) section, meaning that the browser should cache all the listed resources in the application cache. Resources can be specified using either absolute or relative URLs (e.g., <code>index.html</code>).</p>

<p>The "v1" comment in the example above is there for a good reason. Browsers only update an application cache when the manifest file changes, byte for byte. If you change a cached resource (for example, you update the <code>header.png</code> image with new content), you must also change the content of the manifest file in order to let browsers know that they need to refresh the cache. You can make any change you want to the manifest file, but revising a version number is the recommended best practice.</p>

<div class="warning"><strong>Important:</strong> Do not specify the manifest itself in the cache manifest file, otherwise it will be nearly impossible to inform the browser a new manifest is available.</div>

<h3 id="Sections_in_a_cache_manifest_file_CACHE_NETWORK_and_FALLBACK">Sections in a cache manifest file: <code>CACHE</code>, <code>NETWORK</code>, and <code>FALLBACK</code></h3>

<p>A manifest can have three distinct sections: <code>CACHE</code>, <code>NETWORK</code>, and <code>FALLBACK</code>.</p>

<dl>
 <dt><code>CACHE:</code></dt>
 <dd>This is the default section for entries in a cache manifest file. Files listed under the <code>CACHE:</code> section header (or immediately after the <code>CACHE MANIFEST</code> line) are explicitly cached after they're downloaded for the first time.</dd>
 <dt><code>NETWORK:</code></dt>
 <dd>Files listed under the <code>NETWORK:</code> section header in the cache manifest file are white-listed resources that require a connection to the server. All requests to such resources bypass the cache, even if the user is offline. The wildcard character <code>*</code> can be used once. Most sites need <code>*</code>.</dd>
 <dt><code>FALLBACK:</code></dt>
 <dd>The <code>FALLBACK:</code> section specifies fallback pages the browser should use if a resource is inaccessible. Each entry in this section lists two URIs—the first is the resource, the second is the fallback. Both URIs must be relative and from the same origin as the manifest file. Wildcards may be used.</dd>
</dl>

<p>The <code>CACHE</code>, <code>NETWORK</code>, and <code>FALLBACK </code>sections can be listed in any order in a cache manifest file, and each section can appear more than once in a single manifest.</p>

<h3 id="Example_2_a_more_complete_cache_manifest_file">Example 2: a more complete cache manifest file</h3>

<p>The following is a more complete cache manifest file for the imaginary web site at <span class="nowiki">www.example.com</span>:</p>

<pre class="eval notranslate">CACHE MANIFEST
# v1 2011-08-14
# This is another comment
index.html
cache.html
style.css
image1.png

# Use from network if available
NETWORK:
network.html

# Fallback content
FALLBACK:
. fallback.html
</pre>

<p>This example uses <code>NETWORK</code> and <code>FALLBACK</code> sections to specify that the <code>network.html</code> page must always be retrieved from the network, and that the <code>fallback.html</code> page should be served as a fallback resource (e.g., in case a connection to the server cannot be established).</p>

<h3 id="Structure_of_a_cache_manifest_file">Structure of a cache manifest file</h3>

<p>Cache manifest files must be served with the <code>text/cache-manifest</code> MIME type. All resources served using this MIME type must follow the syntax for an application cache manifest, as defined in this section.</p>

<p>Cache manifests are UTF-8 format text files, and may optionally include a BOM character. Newlines may be represented by line feed (<code>U+000A</code>), carriage return (<code>U+000D</code>), or carriage return and line feed both.</p>

<p>The first line of the cache manifest must consist of the string <code>CACHE MANIFEST</code> (with a single <code>U+0020</code> space between the two words), followed by zero or more space or tab characters. Any other text on the line is ignored.</p>

<p>The remainder of the cache manifest must be comprised of zero or more of the following lines:</p>

<dl>
 <dt>Blank line</dt>
 <dd>You may use blank lines comprised of zero or more space and tab characters.</dd>
 <dt>Comment</dt>
 <dd>Comments consist of zero or more tabs or spaces followed by a single <code>#</code> character, followed by zero or more characters of comment text. Comments may only be used on their own lines (after the initial <code>CACHE MANIFEST</code> line), and cannot be appended to other lines. This means that you cannot specify fragment identifiers.</dd>
 <dt>Section header</dt>
 <dd>Section headers specify which section of the cache manifest is being manipulated. There are three possible section headers:</dd>
</dl>

<blockquote>
<table class="standard-table">
 <tbody>
  <tr>
   <th>Section header</th>
   <th>Description</th>
  </tr>
  <tr>
   <td><code>CACHE:</code></td>
   <td>Switches to the explicit section of the cache manifest (this is the default section).</td>
  </tr>
  <tr>
   <td><code>NETWORK:</code></td>
   <td>Switches to the online whitelist section of the cache manifest.</td>
  </tr>
  <tr>
   <td><code>FALLBACK:</code></td>
   <td>Switches to the fallback section of the cache manifest.</td>
  </tr>
 </tbody>
</table>
</blockquote>

<dl>
 <dd>The section header line may include whitespaces, but must include the colon (<code>:</code>) in the section name.</dd>
 <dt>Section data</dt>
 <dd>The format for lines of data varies from section to section. In the explicit (<code>CACHE:</code>) section, each line is a valid URI or IRI reference to a resource to cache (no wildcard characters are allowed in this sections). Whitespace is allowed before and after the URI or IRI on each line. In the Fallback section each line is a valid URI or IRI reference to a resource, followed by a fallback resource that is to be served up when a connection with the server cannot be made. In the network section, each line is a valid URI or IRI reference to a resource to fetch from the network (or the wildcard character <code>*</code> can be used in this section).
 <div class="note"><strong>Note: </strong>Relative URIs are relative to the cache manifest's URI, not to the URI of the document referencing the manifest.</div>
 </dd>
</dl>

<p>Cache manifest files can switch from section to section at will (each section header can be used more than once), and sections are allowed to be empty.</p>

<h2 id="Resources_in_an_application_cache">Resources in an application cache</h2>

<p>An application cache always includes at least one resource, identified by URI. All resources fit into one of the following categories:</p>

<dl>
 <dt>Master entries</dt>
 <dd>These are resources added to the cache because a browsing context visited by the user included a document that indicated that it was in this cache using its <code>manifest</code> attribute.</dd>
 <dt>Explicit entries</dt>
 <dd>These are resources explicitly listed in the application's cache manifest file.</dd>
 <dt>Network entries</dt>
 <dd>These are resources listed in the application's cache manifest files as network entries.</dd>
 <dt>Fallback entries</dt>
 <dd>These are resources listed in the application's cache manifest files as fallback entries.</dd>
</dl>

<div class="note"><strong>Note:</strong> Resources can be tagged with multiple categories, and can therefore be categorized as multiple entries. For example, an entry can be both an explicit entry and a fallback entry.</div>

<p>Resource categories are described in greater detail below.</p>

<h3 id="Master_entries">Master entries</h3>

<p>Master entries are any HTML files that include a {{HTMLAttrxRef("manifest","html")}} attribute in their {{HTMLElement("html")}} element. For example, let's say we have the HTML file <a href="http://www.example.com/entry.html">http://www.example.com/entry.html</a>, which looks like this:</p>

<pre class="brush: html notranslate">&lt;html manifest="example.appcache"&gt;
  &lt;h1&gt;Application Cache Example&lt;/h1&gt;
&lt;/html&gt;
</pre>

<p>If <code>entry.html</code> is not listed in the <code>example.appcache</code> cache manifest file, visiting the <code>entry.html</code> page causes <code>entry.html</code> to be added to the application cache as a master entry.</p>

<h3 id="Explicit_entries">Explicit entries</h3>

<p>Explicit entries are resources that are explicitly listed in the <code>CACHE</code> section of a cache manifest file.</p>

<h3 id="Network_entries">Network entries</h3>

<p>The <code>NETWORK</code> section of a cache manifest file specifies resources for which a web application requires online access. Network entries in an application cache are essentially an "online whitelist"—URIs specified in the <code>NETWORK</code> section are loaded from the server instead of the cache. This lets the browser's security model protect the user from potential security breaches by limiting access to approved resources.</p>

<p>As an example, you can use network entries to load and execute scripts and other code from the server instead of the cache:</p>

<pre class="eval notranslate">CACHE MANIFEST
NETWORK:
/api
</pre>

<p>The cache manifest section listed above ensures that requests to load resources contained in the <code><a href="http://www.example.com/api/" rel="freelink">http://www.example.com/api/</a></code> subtree always go to the network without attempting to access the cache.</p>

<div class="note"><strong>Note</strong>: Omitting master entries (files that have the <code>manifest</code> attribute set in the <code>html</code> element) from the manifest file would not have the same result, because master entries will be added—and subsequently served from—the application cache.</div>

<h3 id="Fallback_entries">Fallback entries</h3>

<p>Fallback entries are used when an attempt to load a resource fails. For example, let's say the cache manifest file <code><a href="http://www.example.com/example.appcache" rel="freelink">http://www.example.com/example.appcache</a></code> includes the following content:</p>

<pre class="eval notranslate">CACHE MANIFEST
FALLBACK:
example/bar/ example.html
</pre>

<p>Any request to <code><a href="http://www.example.com/example/bar/" rel="freelink">http://www.example.com/example/bar/</a></code> or any of its subdirectories and their content cause the browser to issue a network request to attempt to load the requested resource. If the attempt fails, due to either a network failure or a server error of some kind, the browser loads the file <code>example.html</code> instead.</p>

<h2 id="Cache_states">Cache states</h2>

<p>Each application cache has a <strong>state</strong>, which indicates the current condition of the cache. Caches that share the same manifest URI share the same cache state, which can be one of the following:</p>

<dl>
 <dt><code>UNCACHED</code></dt>
 <dd>A special value that indicates that an application cache object is not fully initialized.</dd>
 <dt><code>IDLE</code></dt>
 <dd>The application cache is not currently in the process of being updated.</dd>
 <dt><code>CHECKING</code></dt>
 <dd>The manifest is being fetched and checked for updates.</dd>
 <dt><code>DOWNLOADING</code></dt>
 <dd>Resources are being downloaded to be added to the cache, due to a changed resource manifest.</dd>
 <dt><code>UPDATEREADY</code></dt>
 <dd>There is a new version of the application cache available. There is a corresponding <code>updateready</code> event, which is fired instead of the <code>cached</code> event when a new update has been downloaded but not yet activated using the <code>swapCache()</code> method.</dd>
 <dt><code>OBSOLETE</code></dt>
 <dd>The application cache group is now obsolete.</dd>
</dl>

<h2 id="Testing_for_updates_to_the_cache_manifest">Testing for updates to the cache manifest</h2>

<p>You can programmatically test to see if an application has an updated cache manifest file, using JavaScript. Since a cache manifest file may have been updated before a script attaches event listeners to test for updates, scripts should always test <code>window.applicationCache.status</code>.</p>

<pre class="brush: js notranslate">function onUpdateReady() {
  console.log('found new version!');
}
window.applicationCache.addEventListener('updateready', onUpdateReady);
if(window.applicationCache.status === window.applicationCache.UPDATEREADY) {
  onUpdateReady();
}</pre>

<p>To manually start testing for a new manifest file, you can use <code>window.applicationCache.update()</code>.</p>

<h2 id="Gotchas">Gotchas</h2>

<ul>
 <li>Never access cached files by using traditional GET parameters (like <code>other-cached-page.html?parameterName=value</code>). This will make the browser bypass the cache and attempt to get it from network. To link to cached resources that have parameters parsed in JavaScript use parameters in the hash part of the link, such as <code>other-cached-page.html#whatever?parameterName=value</code>.</li>
 <li>When applications are cached, updating the resources (files) that are used in a web page is not enough to update the files that have been cached. You must update the cache manifest file itself before the browser retrieves and uses the updated files. You can do this programmatically using <code>window.applicationCache.swapCache()</code>, though resources that have already been loaded will not be affected. To make sure that resources are loaded from a new version of the application cache, refreshing the page is ideal.</li>
 <li>It's a good idea to set expires headers on your web server for <code>*.appcache</code> files to expire immediately. This avoids the risk of caching manifest files. For example, in Apache you can specify such a configuration as follows:<br>
  <code>ExpiresByType text/cache-manifest "access plus 0 seconds"</code></li>
</ul>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.html.manifest")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://web.dev/appcache-removal/">Preparing for AppCache Removal</a> - web.dev blog with useful timeline information</li>
 <li><a href="http://www.html5rocks.com/en/tutorials/appcache/beginner/">HTML5Rocks - A Beginner's Guide to Using the Application Cache</a></li>
 <li><a href="http://appcache.offline.technology/">Appcache Facts</a> - detailed information on AppCache idiosyncrasies</li>
 <li><a href="https://alistapart.com/article/application-cache-is-a-douchebag">A List Apart: Application Cache is a Douchebag</a>
  <ul>
   <li><a href="https://flailingmonkey.com/application-cache-not-a-douchebag">The Application Cache is no longer a Douchebag</a> - an overview of the app cache debugging tools added in Firefox 23.</li>
  </ul>
 </li>
 <li><a href="https://hacks.mozilla.org/2010/01/offline-web-applications/">offline web applications</a> at hacks.mozilla.org - showcases an offline app demo and explains how it works.</li>
 <li><a href="https://html.spec.whatwg.org/multipage/offline.html#offline">HTML 5 working draft: Offline web applications</a></li>
 <li><a href="https://www.w3.org/TR/offline-webapps/">W3C Working Group Note: Offline Web Applications</a></li>
 <li><a href="http://developer.teradata.com/blog/js186040/2011/11/html5-cache-manifest-an-off-label-usage">HTML5 Cache Manifest: An Off-label Usage</a></li>
 <li><a href="http://www.ibm.com/developerworks/web/library/wa-ffox3/">Get ready for Firefox 3.0 - A Web developer's guide to the many new features in this popular browser, especially the offline application features</a> (IBM developerWorks)</li>
 <li><a href="/en-US/docs/Application_cache_implementation_overview">Application cache implementation overview</a></li>
 <li><a href="//www.onlinewebcheck.com/check.php?adv=1">OnlineWebCheck.com - Check cache manifest file syntax</a> (Desktop app for Windows)</li>
</ul>
